var showDayNight = false;
var wtHtmlRequest;
var wtCitiesTZ = [];				// Cities' time zones, leave it blank.
var wtDayLastUpdate = 0;
var wtMinuteLastUpdate = 0;
var showCityName = false;


// Main clock section ====================================================================

function updateTime(){
	window.clearTimeout(clockTimer);
	var now = new Date();
	document.getElementById("time").innerHTML = now.format(clock_format_time);
	clockTimer = window.setTimeout(updateTime, 1000 - (now.getTime() % 1000));

	// World Time: only update if displaying Day/night, the World Times and last update was last minute
	if ((showDayNight) && (wtShowWorldTimes) && (wtMinuteLastUpdate != now.getMinutes())) { 
		wtUpdateTime();
	}
}


// Calendar section ====================================================================

function updateClock(){
	var now = new Date();
	var today = now.getDate();
	now.setMonth(now.getMonth() + clockSwitchMonth);

	var dateHTML = "<table><tr><TD align='right'><div class='displayDate'>";
	if (clockSwitchMonth == 0) {
		dateHTML += now.format("l")
	} else {
		dateHTML += now.format("Y")
	}
	now.setDate(1);

	dateHTML += "<BR>"+now.format("F")+"</DIV></TD><Td class='todayClock' width='40px' align='center'>";
	dateHTML += "<div class='timeClock' onclick='event.stopPropagation();clockReset();' ontouchstart='event.stopPropagation();'>" + today.toString() +"</DIV></Td></TR></table>";
	document.getElementById("date").innerHTML = dateHTML;

	if(showMonth){
		var beginDate = new Date(now).zeroTime();
		beginDate.setDate(1);
		var endDate = new Date(beginDate);
		endDate.setMonth(beginDate.getMonth() + 1);

		var current = new Date(beginDate);

		current.setDate(current.getDate() + (startDay - beginDate.getDay()) - (startDay - beginDate.getDay() > 0 ? 7 : 0));

		var t = document.createElement("TABLE");
		t.id = "Month";
		t.align = "center";
		var tb = document.createElement("TBODY");
		var header = document.createElement("TR");
		for(var i = 0; i < 7; i++){
			var cell = document.createElement("TH");
			cell.width = "14%";
			cell.innerHTML = shortDays[(i + startDay) % 7];
			header.appendChild(cell);
		}
		tb.appendChild(header);
		while(current < endDate){
			var row = document.createElement("TR");
			for(var i = 0; i < 7; i++){
				var cell = document.createElement("TD");
				var date = current.getDate();
				if (clockSwitchMonth == 0) {
				  cell.className = beginDate.getMonth() == current.getMonth() ? (today == date ? "today" : "thisMonth") : "otherMonth";
				} else {
				  cell.className = beginDate.getMonth() == current.getMonth() ? "thisMonth" : "otherMonth";
				}
				cell.innerHTML = date;
				current.setDate(date + 1);
				row.appendChild(cell);
			}
			tb.appendChild(row);
		}
		t.appendChild(tb);
		monthDIV.innerHTML = "";
		monthDIV.appendChild(t);
	}

	updateTime();
	window.clearTimeout(dayTimer);
	dayTimer = window.setTimeout(updateClock, new Date(now.getTime() + 86400000).zeroTime().getTime() - now.getTime());

	clockDIV.potentialHeight = clockDIV.offsetHeight;

	if(collapsed["Clock"] && showMonth){
		collapsed["Clock"] = false;
		toggleSection([clockDIV, true]);
	}
}

function clockSwipeLeft() {
  clockSwitchMonth = clockSwitchMonth + 1;
  updateClock();
}

function clockSwipeRight() {
  clockSwitchMonth = clockSwitchMonth - 1;
  updateClock();
}

function clockReset() {
  clockSwitchMonth = 0;
  updateClock();
}


// Day and Night section ====================================================================

function updateDayNight() {
	if (showDayNight) {
		setTimeout(updateDayNight, dnRefreshTimer);	// Set refresh to 10 mins (dnRefreshTimer)
	}
	var GlobalMapImage = "Icon Sets/daynight/globalmap"+ dnGlobalMapIndex + iconExt;

	var clipnighttop;
	var clipnightbottom;
	var clipnightright=0;
	var clipnightleft=0;
	var clipnightpoints;

	var differencehours;
	var differencepixels;
	var now = new Date();
	var utchours=now.getUTCHours();
	var monthimagediff = 0;	// use images 21-32 for days between 15-31
	if (now.getDate() > 14) { monthimagediff = 20; }
	var monthimage= "Icon Sets/daynight/" + (now.getMonth() + 1 + monthimagediff) + iconExt;

	var GlobalMapSize = "width='"+GlobalMapWidth+"' height='"+GlobalMapHeight+"'";
	document.getElementById("GlobalMap").innerHTML= "<img src='"+GlobalMapImage+"' "+ GlobalMapSize +">";
	document.getElementById("nightzoneright").innerHTML="<img src='"+monthimage+"' "+ GlobalMapSize +">";
	document.getElementById("nightzoneleft").innerHTML= "<img src='"+monthimage+"' "+ GlobalMapSize +">";

	differencepixels = GlobalMapWidth/24 * utchours;

	// calculating left night zone
	var dnNightZoneLeftOffset = - Math.round(differencepixels);
	document.getElementById("nightzoneleft").style.posLeft = dnNightZoneLeftOffset;
	clipnightleft = - dnNightZoneLeftOffset;
	clipnightright = GlobalMapWidth;
	clipnighttop=0;
	clipnightbottom = GlobalMapHeight;
	clipnightpoints = "rect("+clipnighttop+" "+clipnightright+" "+clipnightbottom+" "+clipnightleft+")";
	document.getElementById("nightzoneleft").style.clip=clipnightpoints;
	document.getElementById("nightzoneleft").style.visibility="visible";

	// calculating right night zone
	var dnNightZoneRightOffset = dnNightZoneLeftOffset + GlobalMapWidth;
	document.getElementById("nightzoneright").style.posLeft = dnNightZoneRightOffset;
	clipnightleft = 0;
	clipnightright = GlobalMapWidth - dnNightZoneRightOffset;
	clipnighttop=0;
	clipnightbottom = GlobalMapHeight;
	clipnightpoints = "rect("+clipnighttop+" "+clipnightright+" "+clipnightbottom+" "+clipnightleft+")";
	document.getElementById("nightzoneright").style.clip = clipnightpoints;
	document.getElementById("nightzoneright").style.visibility = "visible";

	// World Time: only update if displaying Day/night, the World Times and last update was not today
	if ((showDayNight) && (wtShowWorldTimes) && (wtDayLastUpdate != now.getDate())) {
		fetchWorldTimeData(wtURLSource);
	}
}

function toggleDayNight(blnShowDN) {
  showDayNight = blnShowDN;
  if (blnShowDN) {
    daynightDIV.style.display = "block";
    if (showMonth) { monthDIV.style.display = "none"; }
    updateDayNight();
  } else {
    if (showMonth) { monthDIV.style.display = "block"; }
    daynightDIV.style.display = "none";
  }
}

function callingDayNight(){
  if (collapsed[document.getElementById("Clock").id])	{	// it's collapsed
    toggleDayNight(true);		// turn on Day Night
    toggleSection([clockDIV]);		// uncollapse clock
  } else {
    if (showDayNight) {			// it's on Day Night - Do collapse
      toggleDayNight(false);		// just turn off Day Night
      toggleSection([clockDIV]);  	// collapse clock
    } else {
      toggleDayNight(true);		// turn on Day Night
    }
  }
}

function toggleSectionClock() {
  if (collapsed[document.getElementById("Clock").id])	{	// it's collapsed
    toggleDayNight(false);		// turn off Day Night
    toggleSection([clockDIV]);  	// uncollapse clock
  } else {							// it's uncollapsed
    if (showDayNight) {			// it's on Day Night - Do not collapse
      toggleDayNight(false);		// just turn off Day Night
    } else {
      toggleSection([clockDIV]);  	// collapse clock
    }
  }
}

function dnSwipeLeft() {
  dnGlobalMapIndex = dnGlobalMapIndex + 1;
  if (dnGlobalMapIndex > dnGlobalMapMax) { dnGlobalMapIndex = 1; }
  updateDayNight();
}

function dnSwipeRight() {
  dnGlobalMapIndex = dnGlobalMapIndex - 1;
  if (dnGlobalMapIndex < 1) { dnGlobalMapIndex = dnGlobalMapMax; }
  updateDayNight();
}


// Main clock section ====================================================================

function fetchWorldTimeData(url) {
  for(var i = 0; i < wtCities.length; i++) {
    document.getElementById("wtCities"+i).innerHTML = "--:--";
  }

  if(typeof(netscape) == "object") netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');
  wtHtmlRequest = new XMLHttpRequest();
  wtHtmlRequest.onreadystatechange = processWTReqChange;
  wtHtmlRequest.overrideMimeType("text/html");
  wtHtmlRequest.open("GET", url, true);
  wtHtmlRequest.setRequestHeader("Cache-Control", "no-cache");
  wtHtmlRequest.send(null);

}

function processWTReqChange() {
  if (wtHtmlRequest.readyState == 4) {		// only if "OK"
    if (wtHtmlRequest.status == 200) {		// we got data
      var wtNow = new Date();
      wtDayLastUpdate = wtNow.getDate();	// update occurs every day (using updateDayNight timer)
      var wtContent = wtHtmlRequest.responseText;

      var weekday = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"];
      var wtDayOffSet = 0;
      wtContent = wtContent.replace(/\">/g,"|");
      wtContent = wtContent.replace(/<\/td>/g,"|");
      wtContent = wtContent.replace(/Zürich/g,"Zurich");

      var wtToken = wtContent.split("city=");
      wtToken[0] = "";					// just clearing some memory space

      var wtAtLeastOneCityFound = false;

      for(var i = 0; i < wtCities.length; i++) {
	var wtCityPos = 0;
	var wtCityNameToSearch = wtCities[i][5];	// check if there is a city override
	if (wtCityNameToSearch.length == 0) { wtCityNameToSearch = wtCities[i][0]; }

        for(var j = 1; j < wtToken.length; j++) {

	  wtCityPos = wtToken[j].search(wtCityNameToSearch);			// search city/city override
	  if (wtCityPos > -1) {							// Found city
	    wtAtLeastOneCityFound = true;

	    var wtTokenSub = wtToken[j].split("|");
	    var wtTimeToken = wtTokenSub[3].split(" ");				// Result: "Thu", "3:34", "PM"

	    var wtDayOffSet = weekday.indexOf(wtTimeToken[0]) - wtNow.getDay();	// Result: -1, 0, 1
	    if (wtDayOffSet > 1) { wtDayOffSet -= 7; }				// Adjustment
	    if (wtDayOffSet < -1) { wtDayOffSet += 7; }				// Adjustment

	    var wtCityHour = parseInt(wtTimeToken[1]);

	    if (wtTimeToken.length == 3) { 		// AM/PM format
	      if (wtTimeToken[2].search("PM") > -1) { 
	        if (wtCityHour < 12) { wtCityHour += 12; }	// 12 PM should stay 12, otherwise, add 12
	      }
	      if (wtTimeToken[2].search("AM") > -1) { 
	        if (wtCityHour == 12) { wtCityHour = 0 };		// 12 AM should be 0
	      }
	    }

	    wtCities[i][4] = wtCityHour - wtNow.getHours() + wtDayOffSet * 24;

	    j = wtToken.length;  				// we found it, so skip the other towns...
	  }
	}
      }

      if (wtAtLeastOneCityFound) {
	document.getElementById("wtRefresh").style.display = "none";
      } else {
	document.getElementById("wtRefresh").style.display = "block";
      }

      wtUpdateTime();
    } else {
      // could not get the data, Will try again when user clicks on the TIME
      wtDayLastUpdate = 0;		// set the last update to 0...
    }
  }
}


function wtUpdateTime() {
  // time display
  var wtTIMEdisplay = document.getElementById("time").innerHTML;

  var wtNow = new Date();
  var wtTimeHTML = "";
  wtMinuteLastUpdate = wtNow.getMinutes();

  for(var i = 0; i < wtCities.length; i++) {
    if (showCityName) {
      wtTimeHTML = wtCities[i][0];
    } else {
      var wtNewTime = new Date();
      wtNewTime.setHours(wtNewTime.getHours() + wtCities[i][4]);
      if (wtTIMEdisplay.search("m") > -1) {	// we are on AM/PM
        if (wtNewTime.getHours() < 12) {
          document.getElementById("wtCities"+i).className = "wt_WorldTimeAM" ;
        } else {
          document.getElementById("wtCities"+i).className = "wt_WorldTimePM" ;
        }
        wtTimeHTML = wtNewTime.format("g");
      } else {	// 24 hour format
        wtTimeHTML = wtNewTime.format("G");
      }
      wtTimeHTML += ":" + wtNewTime.format("i");
    }
    document.getElementById("wtCities"+i).innerHTML = wtTimeHTML ;
  }
}

function wtToggleCityTime() {
  wtShowWorldTimes = !wtShowWorldTimes;
  if (wtShowWorldTimes) {
    document.getElementById("WorldTimes").style.display = "block";
  } else {
    document.getElementById("WorldTimes").style.display = "none";
  }
}

function wtToggleCityName() {
  showCityName = !showCityName;
  wtUpdateTime();
}
